Redmine - Defect #41749

Warning during startup: "Unresolved or ambiguous specs during Gem::Specification.reset"
2024-11-14 05:53 - Katsuya HIDAKA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Gems support Estimated time: 0.00 hour
Target version: 5.1.5

Resolution: Fixed Affected version: 6.0.1
Description

This patch resolves a warning that appears when running bin/rails server, bin/rails db:migrate, and similar commands on the
Redmine trunk.

WARN: Unresolved or ambiguous specs during Gem::Specification.reset:
stringio (>= 0)
Available/installed versions of this gem:
- 3.1.2
- 3.1.1

Cause:

The warning originates from the following section in the Gemfile:
https://github.com/redmine/redmine/blob/7 1bcd6df89079b8d33abae39df104a25906b6234/Gemfile#L.56

Redmine's Gemfile uses require 'yaml' to parse config/database.yml for extracting adapter values (e.g., sqlite3, mysql2, postgres)
and loading the required database gems:
https://github.com/redmine/redmine/blob/71bcd6df89079b8d33abae39df104a25906b6234/Gemfile#L.57-1L.84

Since yaml depends on the psych gem, which in turn depends on stringio gem, RubyGems encounters an unresolved or ambiguous
dependency for stringio, as it cannot determine whether to load version 3.1.1 (bundled with Ruby 3.3.6) or the latest available 3.1.2
version. This ambiguity results in the warning message.

Solution:

To avoid this warning, this patch replaces the use of YAML in the Gemfile for reading database.yml and instead directly extracts
adapter values without loading yaml. This eliminates the stringio dependency conflict and removes the warning.

Testing:

All tests have passed in the Cl build: Cl Results. Additionally, | manually verified that sqlite3 and postgresqgl work fine.

Related issues:
Related to Redmine - Defect #42013: Redmine fails to start with error: Unknow... Closed

Associated revisions

Revision 23269 - 2024-11-14 10:11 - Go MAEDA

Fix warning during startup: "Unresolved or ambiguous specs during Gem::Specification.reset" (#41749).

Patch by Katsuya HIDAKA (user:hidakatsuya).

Revision 23273 - 2024-11-15 00:47 - Go MAEDA
Merged r23269 from trunk to 6.0-stable (#41749).

Revision 23286 - 2024-11-17 05:56 - Go MAEDA
Merged r23269 from trunk to 5.1-stable (#41749).

History

#1 - 2024-11-14 05:57 - Katsuya HIDAKA
https://github.com/redmine/redmine/blob/71bcd6df89079b8d33abae39df104a25906b6234/Gemfile#L56
https://github.com/redmine/redmine/blob/71bcd6df89079b8d33abae39df104a25906b6234/Gemfile#L57-L84
https://github.com/hidakatsuya/redmine/actions/runs/11830102485

- File 0001-Fixed-Unresolved-or-ambiguous-specs-during-Gem-Specification.reset-warning.patch added

Here is the patch to resolve the warning.

#2 - 2024-11-14 06:06 - Go MAEDA
- Category set to Gems support
- Status changed from New to Confirmed

- Target version set to 6.0.2

| am setting the target version to 6.0.2.

#3 - 2024-11-14 08:09 - Katsuya HIDAKA
- File 0002-Load-and-process-ERB-only-when-database.yml-contains-ERB-syntax-for-adapter-setting.patch added

The submitted patch (0001-Fixed-*.patch) removes require 'erb’, so it will not work correctly if the adapter in database.yml is set using ERB, such as
<%= ENV['DB_ADAPTER'] %>. To address this issue, |'ve added an additional patch that only requires 'erb' when database.yml contains adapter:
<%= syntax.

I've confirmed the following:

¢ Cl tests passed: Cl Results
e The patch works correctly with the following database.yml configuration:

development:
adapter: <%= ENV['DB_ADAPTER'] %>
database: db/development.sglite3
test:
adapter: <%= ENV['DB_ADAPTER'] %>
database: db/test.sglite3
production:
adapter: <%= ENV['DB_ADAPTER'] %>
database: db/development.sglite3

$ DB_ADAPTER=sqglite3 bundle

Fetching gem metadata from https://rubygems.org/.........
Resolving dependencies...

Fetching sglite3 1.7.3 (x86_64-1inux)

Installing sqglite3 1.7.3 (x86_64-1inux)

#4 - 2024-11-14 10:25 - Go MAEDA

- Subject changed from Fix “Unresolved or ambiguous specs during Gem::Specification.reset” Warning to Warning during startup: "Unresolved or
ambiguous specs during Gem::Specification.reset"

- Status changed from Confirmed to Resolved
- Assignee set to Go MAEDA

- Resolution set to Fixed

I have committed the fix in r23269. Thank you for your contribution.

Please note that if ERB is used in database.yml to specify the database adapter name, the warning will still appear. This is because require 'erb' is
necessary to parse the ERB.

However, in many environments where ERB is not used in database.yml, this change eliminates the warning.

#5 - 2024-11-15 00:53 - Go MAEDA
- Target version changed from 6.0.2 to 5.1.5

Merged the change in the trunk into the 6.0-stable branch in r23273.

#6 - 2024-11-15 18:38 - Marius BALTEANU

- Status changed from Resolved to Reopened

With this change, installations that use a database.yml configuration that contains <%= ENV[<name>] %> in any key except adapter will fail.

| prefer to keep to warning instead of delivering this potential breaking change in a patch / maintenance release.
https://github.com/hidakatsuya/redmine/actions/runs/11831723117/job/32967347299
https://www.redmine.org/projects/redmine/repository/svn/revisions/23269
https://www.redmine.org/projects/redmine/repository/svn/revisions/23273

#7 - 2024-11-15 18:56 - Marius BALTEANU
Marius BALTEANU wrote in #note-6:

With this change, installations that use a database.yml configuration that contains <%= ENV[<name>] %> in any key except adapter will fail.

| prefer to keep to warning instead of delivering this potential breaking change in a patch / maintenance release.

If we really want to fix this warning, we can scan for something like <%= ENV in the entire file instead of looking only on the adapter line.

#8 - 2024-11-16 02:09 - Go MAEDA
Marius BALTEANU wrote in #note-6:

With this change, installations that use a database.yml configuration that contains <%= ENV[<name>] %> in any key except adapter will fail.

No, such an issue will not occur. This is because the purpose of the code in the Gemfile is solely to retrieve the list of database adapters used in
database.yml and install the necessary gems. Database connections are managed by Rails, and the expansion of environment variables for that
purpose is also handled by Rails.

For example, the following database.yml works even on the latest trunk:

production: &sqglite
adapter: sglite3
database: db/<%= ENV['DB_FILENAME'] %>

development: *sglite

$ svn info

Path:

Working Copy Root Path: /private/tmp/trunk

URL: https://svn.redmine.org/redmine/trunk

Relative URL: */trunk

Repository Root: https://svn.redmine.org/redmine
Repository UUID: e93f8b46-1217-0410-a6£0-8£f06a7374b81
Revision: 23276

Node Kind: directory

Schedule: normal

Last Changed Author: maeda

Last Changed Rev: 23276

Last Changed Date: 2024-11-15 09:58:56 +0900 (Fri, 15 Nov 2024)

$ rm db/redmine.sglite3

$ export DB_FILENAME=redmine.sglite3

$ bin/rake db:migrate RAILS_ENV=production
== 1 Setup: migrating

—— create_table ("attachments", {:force=>true, :id=>:integer})
-> 0.0004s

—— create_table ("auth_sources", {:force=>true, :id=>:integer})
-> 0.0002s

—— create_table("custom_fields", {:force=>true, :id=>:integer})
-> 0.0002s

$ bin/rails ¢ -e production

Loading production environment (Rails 7.2.2)
redmine-app (prod) > User.first

=>

#<User:0x00000001117£5c30

id: 1,
login: "admin",
hashed_password: "[FILTERED]",

#9 - 2024-11-16 09:04 - Go MAEDA

r23269 not only fixes the warning but also addresses an issue where Redmine may fail to start.

Using require to load a library in the Gemfile can cause not just warnings but also exceptions, potentially preventing Redmine from starting. For
example, in an environment where both psych 5.2.0 and 5.1.2 are available, with psych 5.1.2 specified in Gemfile.lock, the following error may occur
https://www.redmine.org/projects/redmine/repository/svn/revisions/23269

during Redmine startup.
r23269 has also resolved this issue.

$ bin/rails ¢ -e production
WARN: Unresolved or ambiguous specs during Gem::Specification.reset:
stringio (>= 0)
Available/installed versions of this gem:
- 3.1.2
= ol d
- 3.0.4
WARN: Clearing out unresolved specs. Try 'gem cleanup <gem>'
Please report a bug if this causes problems.
/usr/local/lib/ruby/3.2.0/bundler/runtime.rb:304:in "“check_for_activated_spec!': You have already activated ps
ych 5.2.0, but your Gemfile requires psych 5.1.2. Prepending “bundle exec’ to your command may solve this. (Ge
m: :LoadError)
from /usr/local/lib/ruby/3.
from /usr/local/lib/ruby/3.

2.0/bundler/runtime.rb:25:in “block in setup'
2.0/bundler/spec_set.rb:165:in “each'

from /usr/local/lib/ruby/3.2.0/bundler/spec_set.rb:165:in “each'

from /usr/local/lib/ruby/3.2.0/bundler/runtime.rb:24:in "map'

from /usr/local/lib/ruby/3.2.0/bundler/runtime.rb:24:in " setup'

from /usr/local/lib/ruby/3.2.0/bundler.rb:162:in " setup’

from /usr/local/lib/ruby/3.2.0/bundler/setup.rb:10:in “block in <top (required)>"'

from /usr/local/lib/ruby/3.2.0/bundler/ui/shell.rb:159:in “with_level'

from /usr/local/lib/ruby/3.2.0/bundler/ui/shell.rb:111:in ‘silence’

from /usr/local/lib/ruby/3.2.0/bundler/setup.rb:10:in <top (required)>"'

from <internal:/usr/local/lib/ruby/3.2.0/rubygems/core_ext/kernel_require.rb>:86:in “require'
from <internal:/usr/local/lib/ruby/3.2.0/rubygems/core_ext/kernel_require.rb>:86:1in "require'
from /path/to/redmine/config/boot.rb:6:in “<top (required)>'

from bin/rails:3:in “require_relative'

from bin/rails:3:in "~ <main>'

#10 - 2024-11-16 11:06 - Marius BALTEANU

You're right, sorry for that! It seems that the fail on my local environment was caused by something else. I've rerun some tests now and it looks fine.

#11 - 2024-11-17 05:56 - Go MAEDA

- Status changed from Reopened to Closed

Merged the change in the trunk into the 6.0-stable branch in r23286.

#12 - 2024-12-05 16:57 - Thomas Hoffmann

Will this fix be available in 6.0.2?
Currently, it is not listed at https://www.redmine.org/versions/202

#13 - 2024-12-06 05:11 - Go MAEDA

Thomas Hoffmann wrote in #note-12:

Will this fix be available in 6.0.2?
Currently, it is not listed at https://www.redmine.org/versions/202

This fix will be included in version 5.1.5 and 6.0.2. Redmine 6.0.2 will include all changes in 5.1.5.

#14 - 2024-12-18 13:31 - Héctor Molinero

It seems that this change produces an error if the YAML contains explicitly quoted strings (which is perfectly valid and recommended), for example
the official Docker image generates the following file:

production:
adapter: "mysgl2"
#[...]

https://github.com/docker-library/redmine/issues/353
https://github.com/docker-library/redmine/issues/354

#15 - 2024-12-19 00:52 - Go MAEDA
- Related to Defect #42013: Redmine fails to start with error: Unknown database adapter ""mysql2"" found in config/database.yml added
https://www.redmine.org/projects/redmine/repository/svn/revisions/23269
https://www.redmine.org/projects/redmine/repository/svn/revisions/23286
https://www.redmine.org/versions/202
https://www.redmine.org/versions/202
https://github.com/docker-library/redmine/issues/353
https://github.com/docker-library/redmine/issues/354

#16 - 2024-12-19 04:30 - Go MAEDA
Héctor Molinero wrote in #note-14:
It seems that this change produces an error if the YAML contains explicitly quoted strings (which is perfectly valid and recommended), for

example the official Docker image generates the following file:

(-]

https://github.com/docker-library/redmine/issues/353
https://github.com/docker-library/redmine/issues/354

The issue was fixed in #42013.

Files
0001-Fixed-Unresolved-or-ambiguous-specs-during-Gem-Specification.fe@etBarning.p20&4-11-14 Katsuya HIDAKA
0002-Load-and-process-ERB-only-when-database.yml-contains-ERB4gBaiefor-adapte2oatiint.patch Katsuya HIDAKA
